<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Core {
    private $appid; // 公众号的appid
    private $appsecret; // 公众号的appsecret

    // 构造函数
    function __construct($appid, $appsecret) {
        $this->appid = $appid;
        $this->appsecret = $appsecret;
    }
 
    // 构造函数.兼容PHP4
    function Core($appid, $appsecret) {
        $this->__construct($appid, $appsecret);
    }

    /**
     * +----------------------------------------------------------
     * 用于第一次验证我们网站url合法性
     * +----------------------------------------------------------
     * $token 可由开发者可以任意填写，用作生成签名（该Token会和接口URL中包含的Token进行比对，从而验证安全性）
     * +----------------------------------------------------------
     */
    public function checkSignature($token = '') {
        $signature = $_GET["signature"]; // 微信加密签名，signature结合了开发者填写的token参数和请求中的timestamp参数、nonce参数
        $timestamp = $_GET["timestamp"]; // 时间戳
        $nonce = $_GET["nonce"]; // 随机数
        $echoStr = $_GET["echostr"]; // 随机字符串

        $tmpArr = array($token, $timestamp, $nonce);
        sort($tmpArr);
        $tmpStr = implode($tmpArr);
        $tmpStr = sha1($tmpStr);
        if ($tmpStr == $signature) {
            echo $echoStr;
            exit;
        } else {
            return false;
        } 
    }
 
    /**
     * +----------------------------------------------------------
     * 被动回复微信用户消息函数
     * +----------------------------------------------------------
     */
    public function responseMsg(){
        $xml_str = $GLOBALS['HTTP_RAW_POST_DATA']; // 微信服务器返回来的XML数据
        if (empty($xml_str)) {
            die('');
        }
        if (!empty($xml_str)) {
            // 解析该xml字符串，利用simpleXML
            libxml_disable_entity_loader(true);
            //禁止xml实体解析，防止xml注入
            $request_xml = simplexml_load_string($xml_str, 'SimpleXMLElement', LIBXML_NOCDATA);
            //判断该消息的类型，通过元素MsgType
            switch ($request_xml->MsgType) {
                case 'event':
                    //判断具体的时间类型（关注、取消、点击）
                    $event = $request_xml->Event;
                    if ($event == 'subscribe') { // 关注事件
                        $this->transmitNews($request_xml, $this->media_push_data('subscribe'));
                    } elseif ($event == 'CLICK') { //菜单点击事件
                        $event_key = $request_xml->EventKey;
                        if ($GLOBALS['dou']->value_exist('weixin_media', 'id', $event_key)) {
                            $this->transmitNews($request_xml, $this->media_push_data('menu', $event_key));
                        }
                    }
                break;
                case 'text': //文本消息
                    $content = $request_xml->Content;
                    $this->transmitNews($request_xml, $this->media_push_data('text', $content));
                break;  
            }
        }        
    }
    
    /**
     * +----------------------------------------------------------
     * 微信获取AccessToken 返回指定微信公众号的at信息
     * +----------------------------------------------------------
     */
    public function accessToken($appid = null , $appsecret = null) {
        $appid = is_null($appid) ? $this->appid : $appid;
        $appsecret = is_null($appsecret) ? $this->appsecret : $appsecret;

        $url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" . $appid . "&secret=" . $appsecret;
        $result = $GLOBALS['dou']->curl($url); 
        // print_r($result);
        $jsoninfo = json_decode($result, true);
        $access_token = $jsoninfo["access_token"];

        return $access_token;
    }
 
    /**
     * +----------------------------------------------------------
     * 创建菜单
     * +----------------------------------------------------------
     */
    public function menuSet($menu) {
        $url = 'https://api.weixin.qq.com/cgi-bin/menu/create?access_token=' . $this->accessToken();
        $data = urldecode(json_encode($menu));
        $result_obj = json_decode($GLOBALS['dou']->curl($url, $data));
        if ($result_obj->errcode == 0) {
            return true;
        } else {
            echo $result_obj->errmsg, '<br>';
            return false;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 查询菜单 
     * +----------------------------------------------------------
     */
    public function menuGet() { 
        $url = "https://api.weixin.qq.com/cgi-bin/menu/get?access_token=" . $this->accessToken(); 
        $data = json_decode($GLOBALS['dou']->curl($url, $data), true); // 为true时返回 array 而非 object
        return $data['menu']['button'];
    }
 
    /**
     * +----------------------------------------------------------
     * 菜单删除
     * +----------------------------------------------------------
     */
    public function menuDelete() {
        $url ='https://api.weixin.qq.com/cgi-bin/menu/delete?access_token=' . $this->accessToken();
        $result = $GLOBALS['dou']->curl($url);
        $result_obj = json_decode($result);
        if($result_obj->errcode == 0){
            return true;
        }else{
            return false;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 发送文本消息
     * +----------------------------------------------------------
     */
    private function transmitText($object, $content) {
        if (!isset($content) || empty($content)){
            return "";
        }
        $xmlTpl = "<xml>
                    <ToUserName><![CDATA[%s]]></ToUserName>
                    <FromUserName><![CDATA[%s]]></FromUserName>
                    <CreateTime>%s</CreateTime>
                    <MsgType><![CDATA[text]]></MsgType>
                    <Content><![CDATA[%s]]></Content>
                   </xml>";
        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time(), $content);
        die($result);
    }

    /**
     * +----------------------------------------------------------
     * 发送图文消息
     * +----------------------------------------------------------
     */
    private function transmitNews($object, $newsArray) {
        if(!is_array($newsArray)){
            return "";
        }
        $itemTpl = "<item>
                     <Title><![CDATA[%s]]></Title>
                     <Description><![CDATA[%s]]></Description>
                     <PicUrl><![CDATA[%s]]></PicUrl>
                     <Url><![CDATA[%s]]></Url>
                    </item>"; // 图片链接，支持JPG、PNG格式，较好的效果为大图360*200，小图200*200
        $item_str = "";
        foreach ($newsArray as $item){
            $item_str .= sprintf($itemTpl, $item['Title'], $item['Description'], $item['PicUrl'], $item['Url']);
        }
        $xmlTpl = "<xml>
                    <ToUserName><![CDATA[%s]]></ToUserName>
                    <FromUserName><![CDATA[%s]]></FromUserName>
                    <CreateTime>%s</CreateTime>
                    <MsgType><![CDATA[news]]></MsgType>
                    <ArticleCount>%s</ArticleCount>
                    <Articles>$item_str</Articles>
                   </xml>";
        $result = sprintf($xmlTpl, $object->FromUserName, $object->ToUserName, time(), count($newsArray));
        die($result);
    }

} 

?>